/*
 * Name of Lab
 * Your Name 
 * Your Class
 * Date
 * 
 * Explanation of what the program does.
 * 
 */
import objectdraw.*;
import java.awt.*;

public class Events extends FrameWindowController {

    // The most recently created flower.  Note that when
    // this varibale is declared it has the value "null".
    // See the longer note below for a fuller explanation.
    private Flower lastFlower;

    // Change the color of the last flower or create a  new flower
    public void onMousePress(Location point) {

        // NOTE:  When a variable that is going to refer
        // to an object is declared (e.g. the declaration
        // of lastFlower above) but it does not yet refer 
        // to an actual object (i.e. the object has not 
        // been created yet) the value of that variable is
        // "null".  This is called a "null reference". 
        // In the "if" statement below, if the lastFlower
        // does not equal null it means that lastFlower is
        // referring to an actual flower.  So what the "if" 
        // statement is checking is whether there is an actual
        // flower that lastFlower is referring to AND that
        // flower contains the point where the mouse was
        // pressed.  If either of those is false, it creates
        // a new Flower instead.

        if (lastFlower != null && lastFlower.flowerContains(point)) {
            lastFlower.changeColor();
        } else {
            lastFlower = new Flower(point, canvas.getHeight() * .5, canvas);
        }

    }

    // Make the newest flower grow
    public void onMouseDrag(Location point) {

        // Again, the code is checking to make sure that
        // lastFlower actually points to a Flower.  If it
        // doesn't (i.e. its value is "null") then calling
        // the "grow" method would be an error.

        if (lastFlower != null) {
            lastFlower.grow();
        }

    }

    // Clear the canvas to start again when mouse moves
    // into window
    public void onMouseEnter(Location pt) {
        canvas.clear();
    }

}
